// 
// Linbhand serial communication functions
// Time-stamp: "2007-05-17 18:39:44 sugiura"
// 
// Copyright (c) 2007, Komei Sugiura (komei.sugiura@gmail.com)
// All rights reserved.
// Distributed under the BSD License.
// (See accompanying file license.txt)
// 
// Inspired by Stephen Nestinger's chbhand
// Modified by WATANABE Naoki (voodil@yahoo.co.jp)
// 
// For more detail on serial communication commands, 
// refer to Grasper Control Language Protocol
// www.barretttechnology.com/robot/products/hand/D0AA7A.pdf
// 
// Any comments or suggestions are welcome.


#ifndef GCLserial_h
#define GCLserial_h

#include <iostream>
#include <termios.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>

#include <string>

using namespace std;


class GCLserial
{
public:
   GCLserial::GCLserial(string dev);
   virtual GCLserial::~GCLserial();
   virtual void GCLserial::InitSerial();
   virtual void GCLserial::CloseSerial();
   virtual int GCLserial::CommRead(char * buf);
   virtual int GCLserial::CommWrite(char * buf);
   virtual int GCLserial::CommWrite(string buf);


private:
   int m_fd;			// file descriptor
   string m_dev;

};


#endif
